/*
 * Aipo is a groupware program developed by Aimluck,Inc.
 * Copyright (C) 2004-2008 Aimluck,Inc.
 * http://aipostyle.com/
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package com.aimluck.eip.exttimecard;

import java.io.*;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Iterator;

import org.apache.cayenne.access.DataContext;
import org.apache.cayenne.exp.Expression;
import org.apache.cayenne.exp.ExpressionFactory;
import org.apache.cayenne.query.SelectQuery;
import org.apache.jetspeed.services.logging.JetspeedLogFactoryService;
import org.apache.jetspeed.services.logging.JetspeedLogger;
import org.apache.turbine.util.RunData;
import org.apache.velocity.context.Context;

import com.aimluck.commons.field.ALStringField;
import com.aimluck.commons.field.ALNumberField;
import com.aimluck.eip.cayenne.om.portlet.EipTMemo;
import com.aimluck.eip.cayenne.om.portlet.EipTExtTimecard;
import com.aimluck.eip.cayenne.om.portlet.ImwTJobOrder;
import com.aimluck.eip.common.ALAbstractFormData;
import com.aimluck.eip.common.ALDBErrorException;
import com.aimluck.eip.common.ALPageNotFoundException;
import com.aimluck.eip.exttimecard.util.ExtTimecardUtils;
import com.aimluck.eip.modules.actions.common.ALAction;
import com.aimluck.eip.orm.DatabaseOrmService;
import com.aimluck.eip.services.eventlog.ALEventlogConstants;
import com.aimluck.eip.services.eventlog.ALEventlogFactoryService;
import com.aimluck.eip.util.ALEipUtils;

/**
 * 明日の予定のフォームデータを管理するクラスです。 <BR>
 * 
 */
public class ExtTimecardJobOrderListFormData extends ALAbstractFormData {

  /** logger */
  private static final JetspeedLogger logger = JetspeedLogFactoryService
      .getLogger(ExtTimecardJobOrderListFormData.class.getName());

  /** 受注ID */
  private ALNumberField job_order_id;

  /** 受注名 */
  private String job_order_name;

  private DataContext dataContext;

  /**
   * 
   * @param action
   * @param rundata
   * @param context
   * @see com.aimluck.eip.common.ALAbstractFormData#init(com.aimluck.eip.modules.actions.common.ALAction,
   *      org.apache.turbine.util.RunData, org.apache.velocity.context.Context)
   */
  public void init(ALAction action, RunData rundata, Context context)
      throws ALPageNotFoundException, ALDBErrorException {
    super.init(action, rundata, context);

    dataContext = DatabaseOrmService.getInstance().getDataContext();
    job_order_id.setValue(rundata.getParameters().getString("job_order_id"));
    DataContext dataContext = DatabaseOrmService.getInstance()
    .getDataContext();
    SelectQuery query = new SelectQuery(ImwTJobOrder.class);
    Expression exp11 = ExpressionFactory.matchDbExp(
        ImwTJobOrder.JOB_ORDER_ID_COLUMN, job_order_id);
    query.setQualifier(exp11);
    List joborder = dataContext.performQuery(query);
    ImwTJobOrder imwTJobOrder = (ImwTJobOrder)joborder.get(0);
    job_order_name = imwTJobOrder.getJobOrderName();

// エンティティIDで判断しているにも関わらずユーザーまで限定しようとしているので、以下は不要
// Change 2010/8/23 青柳
/* Expression exp21 = ExpressionFactory.matchExp(
    EipTExtTimecard.USER_ID_PROPERTY, Integer.valueOf(ALEipUtils
        .getUserId(rundata)));
query.andQualifier(exp21);
*/

    
  }

  /**
   * 各フィールドを初期化します。 <BR>
   * 
   * @see com.aimluck.eip.common.ALData#initField()
   */
  public void initField() {
    // 受注ID
    job_order_id = new ALNumberField();
    job_order_id.setFieldName("件名");
    
    job_order_name = null;

  }

  /**
   * Memoの各フィールドに対する制約条件を設定します。 <BR>
   * 
   * @see com.aimluck.eip.common.ALAbstractFormData#setValidator()
   */
  protected void setValidator() {

  }

  /**
   * Memoのフォームに入力されたデータの妥当性検証を行います。 <BR>
   * 
   * @param msgList
   * @return TRUE 成功 FALSE 失敗
   * @see com.aimluck.eip.common.ALAbstractFormData#validate(java.util.ArrayList)
   */
  protected boolean validate(ArrayList msgList) {
    // メモ
//    note.validate(msgList);
    return (msgList.size() == 0);
  }

  /**
   * Memoをデータベースから読み出します。 <BR>
   * 
   * @param rundata
   * @param context
   * @param msgList
   * @return TRUE 成功 FALSE 失敗
   * @see com.aimluck.eip.common.ALAbstractFormData#loadFormData(org.apache.turbine.util.RunData,
   *      org.apache.velocity.context.Context)
   */
  protected boolean loadFormData(RunData rundata, Context context,
      ArrayList msgList) {
    try {
      // オブジェクトモデルを取得
//      EipTExtTimecard timecard = ExtTimecardUtils.getEipTExtTimecard(rundata, context);
//      if (timecard == null)
//        return false;
//
//      // メモ
      job_order_id.setValue(rundata.getParameters().getString("job_order_id"));
    } catch (Exception ex) {
      logger.error("Exception", ex);
      return false;
    }
    return true;
  }

  /**
   * Memoをデータベースから削除します。 <BR>
   * 
   * @param rundata
   * @param context
   * @param msgList
   * @return TRUE 成功 FALSE 失敗
   * @see com.aimluck.eip.common.ALAbstractFormData#deleteFormData(org.apache.turbine.util.RunData,
   *      org.apache.velocity.context.Context)
   */
  protected boolean deleteFormData(RunData rundata, Context context,
      ArrayList msgList) {
    try {
      // オブジェクトモデルを取得
      EipTExtTimecard timecard = ExtTimecardUtils.getEipTExtTimecard(rundata, context);
      if (timecard == null)
        return false;

      // Memoを削除
      dataContext.deleteObject(timecard);
      dataContext.commitChanges();

      // イベントログに保存
//      ALEventlogFactoryService.getInstance().getEventlogHandler().log(
//          memo.getMemoId(), ALEventlogConstants.PORTLET_TYPE_MEMO,
//          memo.getMemoName());

    } catch (Exception ex) {
      logger.error("Exception", ex);
      return false;
    }
    return true;
  }

  /**
   * Memoをデータベースに格納します。 <BR>
   * 
   * @param rundata
   * @param context
   * @param msgList
   * @return TRUE 成功 FALSE 失敗
   * @see com.aimluck.eip.common.ALAbstractFormData#insertFormData(org.apache.turbine.util.RunData,
   *      org.apache.velocity.context.Context, java.util.ArrayList)
   */
  protected boolean insertFormData(RunData rundata, Context context,
      ArrayList msgList) {
    try {
      // 新規オブジェクトモデル
//      EipTMemo memo = (EipTMemo) dataContext
//          .createAndRegisterNewObject(EipTMemo.class);
//
//      Date now = Calendar.getInstance().getTime();
//
//      // メモ
//      memo.setNote(job_order_id.getValue());
//      // 作成日
//      memo.setCreateDate(now);
//      // 更新日
//      memo.setUpdateDate(now);
//      dataContext.commitChanges();

 //     ExtTimecardUtils.saveMemoSelection(rundata, memo.getMemoId().toString());

      // イベントログに保存
//      ALEventlogFactoryService.getInstance().getEventlogHandler().log(
//          memo.getMemoId(), ALEventlogConstants.PORTLET_TYPE_MEMO,
//          memo.getMemoName());

    } catch (Exception ex) {
      logger.error("Exception", ex);
      return false;
    }
    return true;
  }

  /**
   * データベースに格納されているmemoを更新します。 <BR>
   * 
   * @param rundata
   * @param context
   * @param msgList
   * @return TRUE 成功 FALSE 失敗
   * @see com.aimluck.eip.common.ALAbstractFormData#updateFormData(org.apache.turbine.util.RunData,
   *      org.apache.velocity.context.Context, java.util.ArrayList)
   */
  protected boolean updateFormData(RunData rundata, Context context,
      ArrayList msgList) {
    try {
//      // オブジェクトモデルを取得
//      EipTExtTimecard timecard = ExtTimecardUtils.getEipTExtTimecardForUser(rundata, context);
//      if (timecard == null)
//        return false;
//
//      Date now = Calendar.getInstance().getTime();
//
//      // メモ
//      timecard.setPlan(note.getValue());
//      // 更新日
//      timecard.setUpdateDate(now);
//      // Memoを更新
//      dataContext.commitChanges();

      // MemoUtils.saveMemoSelection(rundata, memo.getMemoId().toString());

      // イベントログに保存
//      ALEventlogFactoryService.getInstance().getEventlogHandler().log(
 //         memo.getMemoId(), ALEventlogConstants.PORTLET_TYPE_MEMO,
  //        memo.getMemoName());
    } catch (Exception ex) {
      logger.error("Exception", ex);
      return false;
    }
    return true;
  }

  /**
   * 受注IDを取得します。 <BR>
   * 
   * @return
   */
  public ALNumberField getJobOrderId() {
    return job_order_id;
  }

  /**
   * 件名を取得します。 <BR>
   * 
   * @return
   */
  public String getJobOrderName() {
    return job_order_name;
  }

  /*
   * 何故かUTF8同志の文字比較で不一致を起こして動かなくなったので
   * 調査用に使用。
   * */
  public static String getEncodeType(String rawString) {
   ArrayList<String> encodeType = new ArrayList<String>();
         encodeType.add("UTF-8");
         encodeType.add("UTF-16");
         encodeType.add("MS932");
         encodeType.add("EUC_JP");
         encodeType.add("SJIS");
         encodeType.add("ISO2022JP");
         encodeType.add("JIS0201");
         encodeType.add("JIS0208");
         encodeType.add("JIS0212");
         encodeType.add("Cp930");
         encodeType.add("Cp939");
         encodeType.add("Cp942");
         encodeType.add("Cp943");
         encodeType.add("Cp33722");
         for (Iterator<String> iter = encodeType.iterator(); iter.hasNext();) 
         {
                     String encode = (String) iter.next();
                     String specificEncoded;
                     String autoEncoded;
                     try {
                         specificEncoded = new 
         String(rawString.getBytes("iso-8859-1"),encode);
                         autoEncoded = new 
         String(rawString.getBytes("iso-8859-1"),"JISAutoDetect");
                     } catch (UnsupportedEncodingException e) {
                         return null;
                     }
                     if (specificEncoded.equals(autoEncoded)) {
                         return encode;
                     }
                 }
                 return null;
             }
        
        }
